; PLAYTUNE.ASM  1 Sep 91  MLS
;
; This entire program, source and everything (except for the THD tune), is
;
;    Kopywrong 1991, Atrophied Algorythms
;
; which means you can rip off the source code to your heart's content.  It
; would be nice if you mentioned us, though -- perhaps a one-line credit,
; as appears below for ol' J. P. Garbers?
;
; Be sure to contact us for a list of freebie source code and PD utilities.
;
;
;      ͻ
;                                                                      
;         A  t  r  o  p  h  i  e  d     A  l  g  o  r  y  t  h  m  s   
;            
;                          a Parsec Systems company                    
;      ͼ
;
;                        3567-B Grand Avenue, Suite 117
;                           Gurnee, Illinois  60031
;                             BBS: (708) 244-3591
;
; NOTES:
; 1. Assembled under TASM 2.0.
; 2. I know -- you're not supposed to diddle bits that aren't yours -- but I
;    just had to make the end-of-note fragment clear the noise bits.  If there
;    is something else operating in background that uses sound it is going to
;    get buggered up when you use this.  Watch yourself.  (MLS)
; 3. This mess doesn't work on really fast machines -- the loops operate
;    entirely within the pipeline, so the delays are gone.
; 4. Let us know if you come up with a better note sustain or rest method, eh?
;    I'm thinking about reprogramming the timer chip on the fly, then setting it
;    back again when finished.  It gets messy.  (MLS)

    .model tiny
    .radix 16
    .code
    assume cs:@CODE
    org 100h

; ---------- maintenance conveniences ----------

DATE    equ '1 Sep 91'
PGMR    equ 'MLS'
ARGLIST equ 80
ENDTUNE equ 0FFFF


playtune:  ; jump around all the data and subroutines
    jmp  startit

credits:
    db 0Dh, 0A, 'idea stolen from the 1985 program by J. P. Garbers', 0Dh, 0A
    db 0Dh, 0A
    db 'some music Copyright 1991, THD Tunes, a Parsec Systems Company', 0Dh, 0A

blah:
    db 0Dh, 0A, 'PLAYTUNE - play a tune    ', DATE, '    ', PGMR, 0A
    db 0Dh, 0A, 'Kopywrong 1991, Atrophied Algorythms', 0A
    db 0Dh, 0A, 'usage: PLAYTUNE n [/Tx]', 0A
    db 0Dh, 0A, 'where n is tune ID (1 - 9)', 0A
    db 0Dh, 0A, 'options:', 0A
    db 0Dh, 0A, '    /Tx  set tempo, x = 1 (slow) to 9 (fast); default = 5'
    db 0Dh, 0A, 0A
endblah:

song   db 00
tempo  db 05  ; default to 5 sweeps of the delay
oldPPI db 00
factor dw 0000

tunetabl:
    dw offset tune1, offset tune2, offset tune3, offset tune4, offset tune5
    dw offset tune6, offset tune7, offset tune8, offset tune9

tune1:  ; Close Encounters
    dw 5DC, 0C, 53C, 0C, 6A4, 0C, 0D48, 0C, 8FC, 18, ENDTUNE

tune2:  ; Fairly Close Encounters
    dw 5DC, 0C, 53C, 0C, 6A4, 0C, 8FC, 0C, 474, 18, ENDTUNE

tune3:  ; By No Means Close Encounters
    dw 5DC, 8, 53C, 8, 6A4, 8, 0D48, 8, 8FC, 8, 8FC, 8, 8FC, 8, 0D48, 8
    dw 8FC, 8, 8FC, 8, 8FC, 8, 0FA0, 18, ENDTUNE

tune4:  ; Funeral Dirge
    dw 0FA0, 20, 0FA0, 18, 0FA0, 8, 0FA0, 20, 0D48, 18, 0DAC, 8
    dw 0DAC, 18, 0FA0, 8, 0FA0, 18, 1068, 8, 0FA0, 20, ENDTUNE

tune5:  ; Tallyho!
    dw 7D0, 6, 708, 6, 640, 6, 53C, 3, 0F, 0C, 640, 6, 53C, 18, ENDTUNE

tune6:  ; This tune extract is Copyright 1991, THD Tunes
    dw 11D0, 7, 0A97, 7, 0D58, 7, 11D0, 7, 0A97, 7, 0D58, 7, 11D0, 7
    dw 0BE3, 7, 0E23, 7, 11D0, 7, 0d58, 18, ENDTUNE

tune7:  ; Mary Had a Little Lambkin, Comrade...
    dw 0E23, 10, 0FDF, 6, 11D0, 0A, 0FDF, 0A, 0E23, 0A, 0E23, 0A, 0E23, 0C
    dw 0F, 6, 0FDF, 0A, 0FDF, 0A, 0FDF, 0C, 0F, 6, 0E23, 0A, 0BE3, 0A, 0BE3, 0C
    dw 0F, 6, 0E23, 10, 0FDF, 6, 11D0, 0A, 0FDF, 0A, 0E23, 0A, 0E23, 0A
    dw 0E23, 0A, 0E23, 0A, 0FDF, 0A, 0FDF, 0A, 0E23, 0A, 0FDF, 0A, 11D0, 18
    dw ENDTUNE

tune8:
    dw ENDTUNE

tune9:
    dw ENDTUNE


; ----- determine how fast the machine is to set sensible tone sustain -----

setfac:
    xor ah, ah  ; get current clock tick count
    int 1A
    mov bx, dx  ; hold onto it

wait4tik:  ; wait for the next timer tick so that timing is repeatable
    push bx
    xor ah, ah
    int 1A
    pop bx
    cmp bx, dx
    jz wait4tik   ; repeat until changed

    ; okay, now start measuring
    xor bx, bx    ; clear pass count
    mov cx, dx    ; save current clock ticks

wait5tik:
    push bx             ; pass count
    push cx             ; reference clock tick count
    xor ah, ah
    int 1A
    pop cx
    pop bx
    inc bx
    cmp cx, dx
    jz wait5tik         ; hasn't changed yet
    xor ah, ah
    mov al, [tempo]
    mul bx
    mov [factor], bx    ; save the correction factor
    ret


; ----- al comes in with ASCII value, goes back with numeric value -----

getnum:
    and al, 0F  ; filter the ASCII part to get the real number
    cmp al, 1
    jb help     ; below one
    cmp al, 9
    ja help     ; above nine
    ret


; ----- display the banner, et al -----

help:
    mov ah, 40
    mov bx, 1
    mov cx, offset endblah - offset blah
    mov dx, offset blah
    int 21

quit:
    mov ax, 4C00  ; why report any errors with this toy?
    int 21


; ----- delay generator for sustain -----

fiddle:
    mov cx, [factor]

sustain:
    loop sustain  ; hold note
    dec ax
    jnz fiddle
    ret


; --------------- actual top of program ---------------

startit:
    cld
    xor ax, ax
    mov sp, ax
    mov si, ARGLIST  ; find arguments
    lodsb
    or al, al        ; no args?
    jz help          ; okay, tell ya what...
    mov cl, al       ; length of arg list
    xor ch, ch

skipblnk:  ; skip blanks on the command line
    jcxz help        ; end of command line and still no arguments
    dec cx
    lodsb
    cmp al, ' '      ; skip blanks, eh?
    jz skipblnk
    call getnum      ; look for legitimate number arguments
    mov [song], al

findswch:  ; look for switches
    jcxz findtune  ; end of command line and still no switches
    dec cx
    lodsb
    cmp al, ' '
    jz findswch
    cmp al, '/'    ; forget the minus switch delimeter...
    jnz help       ; bogus switch char
    jcxz help      ; no switch selection
    dec cx
    lodsb
    or al, ' '     ; convert to lowercase
    cmp al, 't'    ; tempo switch
    jnz help       ; that's the only switch (so far)

swchval:  ; extract the switch value
    jcxz help      ; no numeric value, you dummy!
    lodsb
    cmp al, ' '
    jz swchval
    call getnum
    mov bl, 10d    ; set the tempo based on 10 (decimal) as too fast
    sub bl, al
    mov [tempo], bl

findtune:  ; okay, now look up the tune in the table
    xor bh, bh
    mov bl, [song]
    dec bx              ; zero-based offset, of course
    shl bx, 1
    mov si, [bx + offset tunetabl]
    push si
    call setfac         ; get the speed correction set


; ----- great, now play till the end of the tune -----

tone:
    pop si
    lodsw        ; tone value (system clock cycles)
    cmp ax, ENDTUNE
    jz quit
    push si
    push dx      ; save current clock count for use, later popped as cx
    mov bx, ax
    mov al, 0B6  ; set up 8253 timer register to receive div count
    out 43, al
    mov al, bl   ; low byte of count
    out 42, al
    mov al, bh   ; high byte
    out 42, al
    in al, 61    ; read PPI value
    mov [oldPPI], al
    or al, 3     ; turn on speaker
    out 61, al
    pop cx        ; retrieve current clock count (saved as dx)
    pop si
    lodsw         ; get tone duration (delay repeat multiplier)
    push si
    xor bh, bh
    mov bl, [tempo]
    mul bx        ; set delay repeat value for duration
    call fiddle

    ; done playing tone, now silence -- please!  (see Note 2)
    mov al, [oldPPI]   ; restore old PPI value
    and al, 0FC        ; shut up!!
    out 61, al
    xor ah, ah
    mov al, [tempo]
    call fiddle        ; rest a while between notes
    jmp tone

    end playtune
